import copy

import FirestormDialogs as fd
import GlobalVariables as gv
#class data structures for FirestormFleetManager

coreFactions = ['Aquan', 'Sorylian', 'Terran', 'Dindrenzi', 'Directorate', 'Relthoza']

factions = ['Aquan',   'Sorylian', 'Terran', 'Hawker Industries', 'Dindrenzi', 'Directorate', 'Relthoza',
            "Ba'Kash", 'Kedorian', 'Rense System Navy', 'Ryushi', 'Tarakian',
            'Terquai', 'Veydreth', 'Works Raptor', 'Xelocian', 'OSO Corsairs', 'OSO Omnidyne',
            'Oroshan', 'Pathogen', 'STL Syndicate', 'STL Traders']

naturalAllies = {'Aquan': 'Terquai', 'Sorylian':'Veydreth', 'Terran':'Hawker Industries', 
                 'Dindrenzi': 'Rense System Navy', 'Directorate':'Works Raptor', 'Relthoza':"Ba'Kash"}

fleetTactics = {'Aquan':2, 'Sorylian':1, 'Terran':2, 'Hawker Industries':3, 'Ryushi':1, 'Tarakian':1, 'Terquai':2, 'Veydreth':2, 'Xelocian':1,
                'Dindrenzi':3, 'Directorate':1, 'Relthoza':2, "Ba'Kash":2, 'Kedorian':2, 'Rense System Navy':3, 'Works Raptor':2,
                'OSO Corsairs':2, 'OSO Omnidyne':1, 'Oroshan':3, 'Pathogen':1, 'STL Syndicate':2, 'STL Traders':1}

factionBitmapPath = {'Aquan':None, 'Sorylian':None, 'Terran':None, 'Hawker Industries':None, 'Ryushi':None, 'Tarakian':None, 'Terquai':None, 'Veydreth':None, 'Xelocian':None,
                     'Dindrenzi':None, 'Directorate':None, 'Relthoza':None, "Ba'Kash":None, 'Kedorian':None, 'Rense System Navy':None, 'Works Raptor':None,
                     'OSO Corsairs':None, 'OSO Omnidyne':None, 'Oroshan':None, 'Pathogen':None, 'STL Syndicate':None, 'STL Traders':None}

commandDistance = {'Aquan':6, 'Sorylian':7, 'Terran':6, 'Hawker Industries':6, 'Ryushi':8,'Tarakian':7, 'Terquai':7, 'Veydreth':6, 'Xelocian':6,
                   'Dindrenzi':6, 'Directorate':6, 'Relthoza':8, "Ba'Kash":7, 'Kedorian':7, 'Rense System Navy':6, 'Works Raptor':6,
                   'OSO Corsairs':6, 'OSO Omnidyne':6, 'Oroshan':6, 'Pathogen':5, 'STL Syndicate':6, 'STL Traders':5}

kurak = ['Aquan', 'Sorylian', 'Terran', 'Hawker Industries','Terquai','Veydreth','Xelocian','Ryushi','Tarakian']
zenian = ['Dindrenzi','Directorate', 'Relthoza','Rense System Navy','Works Raptor','Kedorian',"Ba'Kash"]
mercenary = ['OSO Corsairs', 'OSO Omnidyne', 'Oroshan', 'STL Syndicate', 'STL Traders', 'Pathogen']

designations = ["Leviathan", "Dreadnought", "Battleship", "Battle_Carrier","Battle_Station", "Carrier", "Heavy_Carrier",
                "Battlecruiser", "Heavy_Cruiser", "Gunship", "Cruiser", "Destroyer", "Frigate",
                "Corvette", "Escort", "Assault_Cruiser", "Torpedo_Cruiser", "RD_Cruiser",
                "Defense_Platform", "Shield_Cruiser", "Shunt_Cruiser", "Drone", "Escort_Carrier", "Light_Frigate",
                "Assault_Carrier", "Light_Cruiser"]

weaponTypes = ['Primary', 'Beam', 'Scatter', 'Kinetic', 'Nuclear', 'Gun Rack']

indirectWeaponTypes = ['Torpedo', 'Nuclear Torpedo', 'Gravitational', 'Cyberwarfare']

srsTypes = {'None': 'No SRS Selected',
            'Fighter':'MV:18"  AD:2  PD:1  AP:0',
            'Interceptor':'MV:12"  AD:0  PD:2  AP:0',
            'Bomber':'MV:12"  AD:3  PD:1  AP:0',
            'Support':'MV:8"  AD:0  PD:0  AP:0',
            'Assault':'MV:8"  AD:0  PD:1  AP:2'}

srsTokens = ['None', 'Fighter', 'Interceptor', 'Bomber', 'Support', 'Assault']

arcs = ['Forward', 'Aft', 'Port', 'Starboard', 'Port/Starboard', 'Any', 'Forward Fixed', 'Aft Fixed','Port Fixed', 'Starboard Fixed', 'Port/Starboard Fixed', 'Port or Starboard' ]


#all ship designations, from all factions, must be included in nullFleet 
#need to use underscore _ and not spaces since these are used in the xml file tags
nullFleet = {"Leviathan":0, "Dreadnought":0, "Battleship":0, "Battle_Carrier":0, "Battle_Station":0, "Heavy_Carrier":0,
             "Carrier":0, "Battlecruiser":0, "Heavy_Cruiser":0, "Gunship":0, "Cruiser":0, "Destroyer":0,
             "Frigate":0, "Corvette":0, "Escort":0, "Assault_Cruiser":0, "Torpedo_Cruiser":0, 
             "RD_Cruiser":0, "Defense_Platform":0, "Shield_Cruiser":0, "Shunt_Cruiser":0, "Drone":0, "Escort_Carrier":0, 
             "Light_Frigate":0, "Assault_Carrier":0, "Light_Cruiser":0}

upgrades = {1000:'Remove the Ablative Plating MAR',
            1002:"Gain +2 Assault Points",
            1001:'Gain the Ambush (2) MAR',
            1003:'Gain the Assault Blitz MAR',
            1004:'Give all Beam Weapons the Biohazard Ammo MAR',
            1005:'Give all Beam Weapons the High Energy MAR',
            1006:'Give all Beam Weapons the Precision Strike MAR',
            1007:'Give all Beam Weapons the Split Fire MAR',
            1008:'Gain the Bigger Batteries MAR',
            1009:'Gain the Countermeasures MAR',
            1010:'Gain the Deck Crews MAR',
            1011:'Gain the Double Mines MAR',
            1012:'Gain the Drone Mines MAR',
            1014:'Give all Beam Weapons the Energy Transfer (1) MAR',
            1015:'Give all Beam Weapons the Energy Transfer (2) MAR',
            1016:'Give all weapons the Energy Transfer (2) MAR',
            1013:'Gain the Experienced Engineers MAR',
            1017:'Give the Fore Fixed Weapons the Decimator Warheads MAR',
            1018:'Give all Gun Racks the Split Fire MAR',
            1019:'Give all Kinetic Weapons the High Energy MAR',
            1020:'Give all Kinetic Weapons the Precision Strike MAR',
            1021:'Gain the Manoeuverable MAR',
            1022:'Give all Mine Weapons the Biohazard Ammo MAR',
            1023:'Gain +3 Mines',
            1024:'Gain the Pack Hunter MAR',
            1025:'Gain the Point Defense Barrage MAR',
            1026:'Gain the Protected Systems MAR',
            1027:'Give all Primary Weapons the Biohazard MAR',
            1028:'Give all Primary Weapons the Decimator Warheads MAR',
            1029:'Give all Primary Weapons the High Energy MAR',
            1030:'Give all Primary Weapons the Precision Strike MAR',
            1031:'Gain the Second Assault MAR',
            1032:'Gain the Quick Launch MAR',
            1033:'Gain the Reinforced (Starboard/Port) MAR',
            1034:'Give all Scatter Weapons the Split Fire MAR',
            1035:'Give Starboard/Port Scatter Weapons the Split Fire MAR',
            1036:'Gain the Sector Shielding MAR',
            1037:'Gain the Secured Bulkheads MAR',
            1038:'Gain the Self Repair MAR',
            1039:'Gain the Special Forces MAR',
            1040:'Give Starboard/Port Weapons the Split Fire MAR',
            1041:'Give all Torpedoes the Biohazard Ammo MAR',
            1042:'Give all Torpedoes the Corrosive MAR',
            1043:'Give all Torpedoes the High Energy MAR',
            1044:'Gain the Torpedo Spook MAR',
            1045:'Gain the Weapon Shielding MAR',
            1046:'Upgrade all Primary Weapons to Scatter Weapons',
            1047:'Upgrade Fore Fixed to a Nuclear Weapon',
            1048:'Upgrade all Torpedoes to Nuclear Torpedoes',
            1049:'Upgrade Primary Weapons to Beam Weapons',
            1050:'Upgrade Starboard/Port Weapons to Beam Weapons',
            1051:'Upgrade Turrets to Nuclear Turrets',
            1052:'Give all Torpedoes the Decimator Warheads MAR',
            1053:'Give all Beam weapons the Corrosive MAR',
            1054:'Gain the Scout MAR',
            1055:'Upgrade the Primary Weapons to a Cyberwarfare Weapon',
            1056:'Give the Beam Weapons the Decimator Warheads MAR',
            1057:'Give all Primary Weapons the Corrosive MAR',
            1058:'Gain the Stealth Systems MAR',
            1059:'Replace Energy Transfer 1 MAR with Energy Transfer 2 MAR',
            1060:'Add +2" Command Distance',
            1061:'Add +1" Movement',
            1062:'Add +3" Command Distance',
            1063:'Upgrade the Scatter weapons to Kinetic weapons',
            1064:'Gain +1 PD',
            1065:'Gain the Weapon Shielding MAR, remove the Durable MAR',
            1066:'Gain +1 Shield Rating',
            1067:'Change Torpedoes to Cyberwarfare weapons with the Assault Robot Torpedoes MAR',
            1068:'Gain the Precision Strike MAR'}
#when adding upgrades, also need to update ShipRecord::ApplyUpgrades method if stats are altered

fleetComposition = {"minPatrolTier1":1, "maxPatrolTier1":2, "minPatrolTier2":1, "maxPatrolTier2":2, "minPatrolTier3":1, "maxPatrolTier3":3,
                    "minBattleTier1":1, "maxBattleTier1":2, "minBattleTier2":1, "maxBattleTier2":2, "minBattleTier3":1, "maxBattleTier3":3,
                    "minGrandTier1":1, "maxGrandTier1":2, "minGrandTier2":1, "maxGrandTier2":2, "minGrandTier3":1, "maxGrandTier3":3,
                    "patrolTier1":None, "patrolTier2":None, "patrolTier3":None,
                    "battleTier1":None, "battleTier2":None, "battleTier3":None,
                    "grandTier1":None, "grandTier2":None, "grandTier3":None}

fleetRaces = {'Aquan':copy.deepcopy(fleetComposition), 'Sorylian':copy.deepcopy(fleetComposition), 'Terran':copy.deepcopy(fleetComposition), 'Hawker Industries':copy.deepcopy(fleetComposition), 'Dindrenzi':copy.deepcopy(fleetComposition),
              'Directorate':copy.deepcopy(fleetComposition), 'Relthoza':copy.deepcopy(fleetComposition), "Ba'Kash":copy.deepcopy(fleetComposition), 'Kedorian':copy.deepcopy(fleetComposition), 'Rense System Navy':copy.deepcopy(fleetComposition),
              'Ryushi':copy.deepcopy(fleetComposition), 'Tarakian':copy.deepcopy(fleetComposition), 'Terquai':copy.deepcopy(fleetComposition), 'Veydreth':copy.deepcopy(fleetComposition), 'Works Raptor':copy.deepcopy(fleetComposition),
              'Xelocian':copy.deepcopy(fleetComposition), 'OSO Corsairs':copy.deepcopy(fleetComposition), 'OSO Omnidyne':copy.deepcopy(fleetComposition), 'Oroshan':copy.deepcopy(fleetComposition), 'Pathogen':copy.deepcopy(fleetComposition),
              'STL Syndicate':copy.deepcopy(fleetComposition), 'STL Traders':copy.deepcopy(fleetComposition)}


class FleetRecord:
  def __init__(self):
    self.fleetName = ''
    self.MFV = 0   #maximum fleet value
    self.CFV = 0   #current fleet value
    self.coreFaction = ''
    self.commandDistance = 0     #command distance for this fleet
    self.tacticsBonus = 0        #tactics bonus
    self.errors = ''
    self.errorFree = True   #set to False if an error in fleet construction was found.
    self.notes = ""      #User defined text for notes
    self.squadronList = []  #list of SquadronRecords()
    self.squadronCount = copy.deepcopy(nullFleet)
    self.restrictToCore = True   #restricted to Core faction only?  False if alliance fleets allowed
    self.restrictToInventory = False
    self.includeMercenaries = False
    self.includeNaturalAllies = False
    
    #these change based on the race and MFV
    #number of squadrons
    self.allowedTier1 = 0
    self.allowedTier2 = 0
    self.allowedTier3 = 0

    self.minTier1 = 0
    self.minTier2 = 0
    self.minTier3 = 0
    
    self.maxTier1 = 0
    self.maxTier2 = 0
    self.maxTier3 = 0
    return
  
  def __deepcopy__(self, source):
    item = FleetRecord()
    item.fleetName = source.fleetName
    item.MFV = source.MFV
    item.CFV = source.CFV
    item.coreFaction = source.coreFaction
    item.squadronCount = source.squadronCount
    item.squadronList = copy.deepcopy(source.squadronList)
    item.restrictToCore = source.restrictToCore
    item.restrictToInventory = source.restrictToInventory
    item.includeMercenaries = source.includeMercenaries
    item.allowedTier1 = source.allowedTier1
    item.allowedTier2 = source.allowedTier2
    item.allowedTier3 = source.allowedTier3
    item.minTier1 = source.minTier1
    item.minTier2 = source.minTier2
    item.minTier3 = source.minTier3
    
    item.maxTier1 = source.maxTier1
    item.maxTier2 = source.maxTier2
    item.maxTier3 = source.maxTier3
    item.notes = source.notes
    return item
    
  def SetFleetMFV(self, MFV):
    self.MFV = MFV
    if (MFV <= 800):
      self.minTier1 = gv.FleetComposition[self.coreFaction]['minPatrolTier1']
      self.minTier2 = gv.FleetComposition[self.coreFaction]['minPatrolTier2']
      self.minTier3 = gv.FleetComposition[self.coreFaction]['minPatrolTier3']
      
      self.maxTier1 = gv.FleetComposition[self.coreFaction]['maxPatrolTier1']
      self.maxTier2 = gv.FleetComposition[self.coreFaction]['maxPatrolTier2']
      self.maxTier3 = gv.FleetComposition[self.coreFaction]['maxPatrolTier3']
      
      self.allowedTier1 = gv.FleetComposition[self.coreFaction]['patrolTier1']
      self.allowedTier2 = gv.FleetComposition[self.coreFaction]['patrolTier2']
      self.allowedTier3 = gv.FleetComposition[self.coreFaction]['patrolTier3']
    elif (MFV <= 1200):
      self.minTier1 = gv.FleetComposition[self.coreFaction]['minBattleTier1']
      self.minTier2 = gv.FleetComposition[self.coreFaction]['minBattleTier2']
      self.minTier3 = gv.FleetComposition[self.coreFaction]['minBattleTier3']
      
      self.maxTier1 = gv.FleetComposition[self.coreFaction]['maxBattleTier1']
      self.maxTier2 = gv.FleetComposition[self.coreFaction]['maxBattleTier2']
      self.maxTier3 = gv.FleetComposition[self.coreFaction]['maxBattleTier3']
      
      self.allowedTier1 = gv.FleetComposition[self.coreFaction]['battleTier1']
      self.allowedTier2 = gv.FleetComposition[self.coreFaction]['battleTier2']
      self.allowedTier3 = gv.FleetComposition[self.coreFaction]['battleTier3']
    else:  # (MFV <=2000):
      self.minTier1 = gv.FleetComposition[self.coreFaction]['minGrandTier1']
      self.minTier2 = gv.FleetComposition[self.coreFaction]['minGrandTier2']
      self.minTier3 = gv.FleetComposition[self.coreFaction]['minGrandTier3']
      
      self.maxTier1 = gv.FleetComposition[self.coreFaction]['maxGrandTier1']
      self.maxTier2 = gv.FleetComposition[self.coreFaction]['maxGrandTier2']
      self.maxTier3 = gv.FleetComposition[self.coreFaction]['maxGrandTier3']
      
      self.allowedTier1 = gv.FleetComposition[self.coreFaction]['grandTier1']
      self.allowedTier2 = gv.FleetComposition[self.coreFaction]['grandTier2']
      self.allowedTier3 = gv.FleetComposition[self.coreFaction]['grandTier3']

    return

  def AddSquadron(self, squadron):
    #add to squadron designation
    self.squadronCount[squadron.ship.designation] += 1
    self.squadronList.append(squadron)
    return

  def RemoveSquadron(self, squadron):
    self.squadronCount[squadron.ship.designation] -= 1
    self.squadronList.remove(squadron)
    return
  
  def SetFleetTacticsAndCommand(self):
    if (self.coreFaction not in factions):
      return
    self.commandDistance = commandDistance[self.coreFaction]
    self.tacticsBonus = fleetTactics[self.coreFaction]
    for squadron in self.squadronList:
      self.tacticsBonus = min(self.tacticsBonus, fleetTactics[squadron.ship.faction])
    return

####################################################################
class MarRecord():
  """
  marIndex is the list index
  
  """
  def __init__(self,index=None, name=None, text=None, summary=None):
    if (index):
      self.marIndex = index
    else:
      self.marIndex = 0

    if (name):
      self.marName = name
    else:
      self.marName = ''

    if (text):
      self.marText = text
    else:
      self.marText = ''
      
    if (summary):
      self.marSummary = summary
    else:
      self.marSummary = self.marText
      
    self.marNumber = 0
    self.valueRequired = False
    self.intValue1 = 0
    self.intValue2 = 0
    self.strValue1 = ''
    self.strValue2 = ''
    return

########################################################################
class srsRecord():
  """"""
  #----------------------------------------------------------------------
  def __init__(self):
    """Constructor"""
    self.srsType = 'None'       # 'None', Fighter, Interceptor, Bomber, Assault, Support // see srsTypes
    self.cost = 0             # this is 5 * numToken
    self.numWings = 0         # number of wings on this token
    return
  
  def SetWingCount(self, value):
    self.numWings = value
    self.SetCost()
    return
  
  def SetCost(self):
    self.cost = self.numWings * 5
    return

class ShipRecord():
  def __init__(self):
    self.shipName = ''
    self.deleted_ship = False  #if True, never show ship.  Ship data is maintained so as to not break indexing
    self.showShip = True  #Set to false if the ship is filtered out
    self.index = None     #unique index for each ship class
    self.faction = ''
    self.className = ''
    self.source = ''      # Official OR Custom
    self.designation = '' # Leviathan, Dreadnought, Battleship, Battle_Carrier, Carrier, Battlecruiser, Heavy_Cruiser, Gunship, Destroyer, Frigate, Corvette, Escort
    self.baseCost = 0
    self.secondaryCost = 0  #cost for marauder units that are out-of-faction
    self.currentCost = 0
    self.squadronSizeMin = 1
    self.squadronSizeMax = 1
    self.classSize = ''    # Large Capital, Medium Capital, Small
    self.DR = 1
    self.CR = 1
    self.HP = 1
    self.MV = 1
    self.TL = 1
    self.CP = 1
    self.AP = 0
    self.PD = 0
    self.SR = 0
    self.MN = 0
    self.WC = 0
    self.commandDistance = 0                #value that this ship affects fleet command distance
    self.cloakingField = False  #True if the ship has a cloaking field
    self.currentSRS = []        #srsRecord
    self.imagePath = None       #folder path only, relative to /ship_image_folder/
    self.factionFilename = None #filename of the faction image, if any
    self.imageFilename = None   #filename of the ship image only
    self.imageCustomFilename = None  #filename of the ship image if custom/user selected
    self.weapons = []
    self.currentWeapons = []         #weapons in use on the fleet ship
    self.maxHardPoints = 0
    self.availableHardPoints = []
    self.currentHardpoints = []      #Hardpoints added to the fleet ship
    self.accompanimentMax = 0
    self.accompanimentIncluded = []    # list of available AccompanimentRecords()
    self.currentAccompaniment = None   # AccompanimentRecord() escorts added to the fleet ship
    self.MAR = []                    # MAR's available to this ship
    self.currentMAR = []             #MAR's currently in use on this ship
    self.upgrades = []
    self.currentUpgrades = []        #upgrades added to the fleet ship
    self.notes = ''
    self.numOwned = 0
    self.numUsed = 0
    self.tier = 0
    return
  
  def ApplyMarValues(self):
    """Apply values found in the MAR for stats, weapons, etc.    This will change descriptions and values, ie, 
    Kinetic -> High Energy Kinetic, AP=0 -> AP=2, etc.  
    Note that not every MAR will affect stats on the ship."""
    #mar = MarRecord()
    #weapon = WeaponRecord()
    
    for mar in self.currentMAR:
      if (mar.marNumber == 3): #ambush
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
      elif (mar.marNumber == 7): #biohazard ammo
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
        for weapon in self.currentWeapons:
          if (mar.strValue1 == weapon.weaponType):
            weapon.weaponUpgrade += "Biohazard "
      elif (mar.marNumber == 9): #corrosive ammo
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
        for weapon in self.currentWeapons:
          if (mar.strValue1 == weapon.weaponType):
            weapon.weaponUpgrade += "Corrosive "
      elif (mar.marNumber == 11): #decimator ammo
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
        for weapon in self.currentWeapons:
          if (mar.strValue1 == weapon.weaponType):
            weapon.weaponUpgrade += "Decimator "
      elif (mar.marNumber == 20): #energy transfer
        mar.marName = mar.marName.replace('type', mar.strValue1)
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
      elif (mar.marNumber == 22): #high energy weapon
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
        for weapon in self.currentWeapons:
          if (mar.strValue1 == weapon.weaponType):
            weapon.weaponUpgrade += "High Energy "
      elif (mar.marNumber == 28): #minefields
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
        mar.marName = mar.marName.replace('AD', str(mar.intValue2))
      elif (mar.marNumber == 33): #precision weapon
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
        for weapon in self.currentWeapons:
          if (mar.strValue1 == weapon.weaponType):
            weapon.weaponUpgrade += "Precision "
      elif (mar.marNumber == 36):  #reinforced
        mar.marName = mar.marName.replace('Arc', mar.strValue1)
      elif (mar.marNumber == 37):  #retractable plating
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
      elif (mar.marNumber == 43):  #shield projector
        mar.marName = mar.marName.replace('Range', str(mar.intValue1))
      elif (mar.marNumber == 44):  #shunt matrix
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
      elif (mar.marNumber == 46): #split fire
        mar.marName = mar.marName.replace('Weapon', mar.strValue1)
        for weapon in self.currentWeapons:
          if (mar.strValue1 == weapon.weaponType):
            weapon.weaponUpgrade += "Split Fire "
      elif (mar.marNumber == 58):  #planetfall
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
      elif (mar.marNumber == 59):  #improved shunt matrix
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
      elif (mar.marNumber == 60):  #energy locus
        mar.marName = mar.marName.replace('value', str(mar.intValue1))
    return
  
  def ApplyHardpoints(self):
    """Apply the current hardpoints to the ship.  This will change descriptions and values, ie, 
       Kinetic -> High Energy Kinetic, etc.   
       Note that not every upgrade will affect stats on the ship; if a stat (CR, AP, etc) was
       modified by the hardpoint, that is saved/loaded separately.
       """
    hardpoint = HardpointRecord()
    
    for hardpoint in self.currentHardpoints:
      if (hardpoint.index == 3):  #change torpedo arc
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.arcRestriction = 'Arc'
      elif (hardpoint.index == 6):  #upgrade to Nuclear Torp
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.weaponType = 'Nuclear Torpedo'
      elif (hardpoint.index == 9):  #Remove Ablative Plating MAR
        for mar in self.currentMAR:
          if (mar.marIndex == 1):
            self.currentMAR.remove(mar)
            break
      elif (hardpoint.index == 11):  #increase Command Distance
        pass
      elif (hardpoint.index == 12):  #upgrade Primary to Beam
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponType = 'Beam'
      elif (hardpoint.index == 13):  #change fixed fore to Scatter
        for weapon in self.currentWeapons:
          if ((weapon.arcDirection == 'Forward') and (weapon.arcRestriction == 'Fixed')):
            weapon.weaponType = 'Scatter'
            weapon.arcRestriction = 'Arc'
      elif (hardpoint.index == 30):  #include the cyberwarfare weapons
        for weapon in self.currentWeapons:
          if (weapon.weaponType == hardpoint.strValue1):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 40):  #change beam fore to cyberwarfare
        for weapon in self.currentWeapons:
          if ((weapon.arcDirection == 'Forward') and (weapon.weaponType == 'Beam')):
            weapon.weaponType = 'Cyberwarfare'
            break
      elif (hardpoint.index == 42):  #change beam to cyberwarfare
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponType = 'Cyberwarfare'
            break
      elif (hardpoint.index == 45):  #include the beam weapons
        for weapon in self.currentWeapons:
          if (weapon.weaponType == hardpoint.strValue1):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 46):  #include the cyberwarfare weapons
        for weapon in self.currentWeapons:
          if (weapon.weaponType == hardpoint.strValue1):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 47):  #include the gravitational weapons and compressor MAR
        for weapon in self.currentWeapons:
          if (weapon.weaponType == hardpoint.strValue1):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 48):  #include the cyberwarfare with Assault Robots MAR
        for weapon in self.currentWeapons:
          if (weapon.weaponType == hardpoint.strValue1):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 49):  #include the torpedo weapons
        for weapon in self.currentWeapons:
          if (weapon.weaponType == hardpoint.strValue1):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 58):  #gain 1 SR, -1 MV
        self.SR += 1
        self.MV -= 1
      elif (hardpoint.index == 59):  #gain -1 HP, difficult target mar
        self.HP -= 1
      elif (hardpoint.index == 60): #gain +3 WC, lose planetfall
        self.WC += 3
      elif (hardpoint.index == 63): #gain +2 MN
        self.MN += 2
      elif (hardpoint.index == 64): #gain +2 MN
        self.MN += 2
      elif (hardpoint.index == 66): #gain +1 SR, +1 HP
        self.SR += 1
        self.HP += 1
      elif (hardpoint.index == 69): #change fore scatter to fore fixed kinetic
        for weapon in ship.currentWeapons:
          if (weapon.weaponType == 'Scatter' and weapon.arcDirection == 'Forward'):
            weapon.weaponType = 'Kinetic'
            weapon.arcRestriction = 'Fixed'
      elif (hardpoint.index == 73): #gain +1 HP, also remove durable mar
        self.HP += 1
      elif (hardpoint.index == 74): #turrets to nuke, remove planetfall mar
        for weapon in ship.currentWeapons:
          if (weapon.category == 'Direct' and weapon.weaponType == 'Primary' and weapon.arcDirection == 'Any'):
            weapon.weaponType = 'Nuclear'
      elif (hardpoint.index == 75):  #+1 planetfall, -2 WC
        self.WC -= 2
      elif (hardpoint.index == 76):  # +3 AP, remove planetfall
        self.AP += 3
      elif (hardpoint.index == 77):  #gain turret weapons
        for weapon in self.currentWeapons:
          if (weapon.arcDirection == 'Any' and weapon.hardpoint == True):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 78):  #gain +1 SR, shield projector 0 mar
        self.SR += 1
      elif (hardpoint.index == 80): #change primaries to scatter
        for weapon in ship.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponType = 'Scatter'
      elif (hardpoint.index == 82):  #+1 planetfall, -3 WC
        self.WC -= 3
      elif (hardpoint.index == 83):  #+1 planetfall, -3 AP
        self.AP -= 3
      elif (hardpoint.index == 84):  #+1 planetfall, -1 SR
        self.SR -= 1
      elif (hardpoint.index == 85):  # +2 AP, remove planetfall
        self.AP += 2
      elif (hardpoint.index == 86):  # +6 AP, remove planetfall
        self.AP += 6
      elif (hardpoint.index == 89):  #gain +4 WC and Quick launch, remove planetfall
        self.WC += 4
      elif (hardpoint.index == 91):  #gain cloaking field mar, remove planetfall
        self.cloakingField = True
      elif (hardpoint.index == 92):  # +3 MN, -2 MV
        self.MV -= 2
        self.MN += 3
      elif (hardpoint.index == 93):  # +1 AP, -1 CP
        self.AP += 1
        self.MN -= 1
      elif (hardpoint.index == 94):  # +2 MV, remove durable mar
        self.MV += 2
      elif (hardpoint.index == 95):  # gain torpedo, remove planetfall
        for weapon in ship.currentWeapons:
          if (weapon.weaponType == 'Torpedo') and (weapon.hardpoint == True):
            weapon.includeAsHardpoint = True
      elif (hardpoint.index == 96):  # +1 planetfall, -2 PD
        self.PD -= 2
      elif (hardpoint.index == 97):  # +1 SR, remove durable mar
        self.SR += 1
      elif (hardpoint.index == 98):  # gain torpedo, add biohazard ammo mar
        for weapon in ship.currentWeapons:
          if (weapon.weaponType == 'Torpedo') and (weapon.hardpoint == True):
            weapon.includeAsHardpoint = True
        
            
    return
  
  def ApplyUpgrades(self):
    """Apply the current upgrades to the ship stats, weapons, etc.  This will change descriptions and values, ie, 
    Kinetic -> High Energy Kinetic, AP=0 -> AP=2, etc.  
    Note that not every upgrade will affect stats on the ship.
    """
    #upg = UpgradeRecord()
    #weapon = WeaponRecord()
    
    #first, clear out the weaponUpgrade modifier.  If the upgrade has been turned off, we catch that here.
    for weapon in self.currentWeapons:
      weapon.weaponUpgrade = ''
    #second, add any relevant modifiers back in.
    for upg in self.currentUpgrades:
      if (upg.index == 1004):  #Beam gains biohazard
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponUpgrade += 'Biohazard '
      elif (upg.index == 1005):  #Beam gains High Energy
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponUpgrade += 'High Energy '
      elif (upg.index == 1006):  #Beam gains Precision Strike
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponUpgrade += 'Precision Strike '
      elif (upg.index == 1007):  #Beam gains Split Fire
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponUpgrade += 'Split Fire '
      elif (upg.index == 1017):  #Fore Fixed gain Decimators
        for weapon in self.currentWeapons:
          if (weapon.arcDirection == 'Forward' and weapon.arcRestriction == 'Fixed'):
            weapon.weaponUpgrade += 'Decimator Warhead '
      elif (upg.index == 1018):  #Gun racks gain split fire
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Gun Rack'):
            weapon.weaponUpgrade += 'Split Fire '
      elif (upg.index == 1019):  #Kinetic gains High Energy
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Kinetic'):
            weapon.weaponUpgrade += 'High Energy '
      elif (upg.index == 1020):  #Kinetic gain Precision
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Kinetic'):
            weapon.weaponUpgrade += 'Precision Strike '
      elif (upg.index == 1027):  #Primaries gain biohazard
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'Biohazard '
      elif (upg.index == 1028):  #Primaries gain Decimator
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'Decimator '
      elif (upg.index == 1030):  #Primaries gain Precision
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'Precision Strike '
      elif (upg.index == 1029):  #Primaries gain High Energy
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'High Energy '
      elif (upg.index == 1034):  #Scatter gain Split Fire
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Scatter'):
            weapon.weaponUpgrade += 'Split Fire '
      elif (upg.index == 1035):  #S/P weapons gain Split Fire
        for weapon in self.currentWeapons:
          if ('Starboard' in weapon.arcDirection or 'Port' in weapon.arcDirection):
            weapon.weaponUpgrade += 'Split Fire '
      elif (upg.index == 1041):  #Torpedo gains Biohazard
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.weaponUpgrade += 'Biohazard '
      elif (upg.index == 1042):  #Torpedo gains Corrosive
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.weaponUpgrade += 'Corrosive '
      elif (upg.index == 1043):  #Torpedo gains High Energy
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.weaponUpgrade += 'High Energy '
      elif (upg.index == 1046):  #Primaries to Scatter
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'Scatter '
      elif (upg.index == 1047):  #Fore Fixed gain Nuclear
        for weapon in self.currentWeapons:
          if (weapon.arcRestriction == 'Fixed'):
            weapon.weaponUpgrade += 'Nuclear '
      elif (upg.index == 1048):  #Torpedo gains Nuclear
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.weaponUpgrade += 'Nuclear '
      elif (upg.index == 1049):  #Primary to Nuclear
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'Nuclear '
      elif (upg.index == 1050):  #S/P weapons gain Split Fire
        for weapon in self.currentWeapons:
          if ('Starboard' in weapon.arcDirection or 'Port' in weapon.arcDirection):
            weapon.weaponUpgrade += 'Beam '
      elif (upg.index == 1051):  #Turrets gain nuclear
        for weapon in self.currentWeapons:
          if (weapon.arcDirection == 'Any'):
            weapon.weaponUpgrade += 'Nuclear '
      elif (upg.index == 1052):  #torpedoes gain decimator warheads
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Torpedo'):
            weapon.weaponUpgrade += 'Decimator'
      elif (upg.index == 1053):  #Beam gains Corrosive
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponUpgrade += 'Corrosive '
      elif (upg.index == 1055):  #primary to cyberwarfare
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponType = 'Cyberwarfare'
            weapon.category = 'Indirect'
      elif (upg.index == 1056):  #Beam gains decimator
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Beam'):
            weapon.weaponUpgrade += 'Decimator '
      elif (upg.index == 1057):  #Primary gains Corrosive
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Primary'):
            weapon.weaponUpgrade += 'Corrosive '
      elif (upg.index == 1060):  #add +3 CMD
        self.commandDistance += 2
      elif (upg.index == 1061):  #add +1 MV
        self.MV += 1
      elif (upg.index == 1062):  #add +3 CMD
        self.commandDistance += 3
      elif (upg.index == 1063):  #scatter to kinetic
        for weapon in self.currentWeapons:
          if (weapon.weaponType == 'Scatter'):
            weapon.weaponType = 'Kinetic'
      elif (upg.index == 1064):  #add +1 pd
        self.PD += 1
      elif (upg.index == 1064):  #add +1 sr
        self.SR += 1
      
#must also update ShipEditorBase::OnAddUpgrade and dataStruct.upgrades()
#update FleetEditorBase::AddUpgrade and FleetEditorBase::RemoveUpgrade

class AccompanimentRecord():
  def __init__(self):
    self.numAllowed = 0
    self.numSelected = 0
    self.shipIndex = None   #shipIndex from the master ship list
    self.accompIndex = None  #index from the accompanimentIncluded list; use for selecting in the radiobox
    self.ship = None   #shipRecord of the accomp
    self.treeID = None  #wxTreeItemId
    return

class WeaponRecord():
  def __init__(self):
    self.weaponName = ''  #optional
    self.category = ''  # Direct or Indirect
    self.weaponType = ''    #if direct: Primary, Beam, Kinetic, Scatter, Nuclear, Gun Rack
                            #if indirect: Torpedo, Nuclear Torpedo, Cyberwarfare, Gravitational
    self.weaponUpgrade = ''  #upgrade modifier to a weapon:  High Energy, Biohazard, etc.
    self.weaponMAR = ''      #MAR modifier to a weapon:  High Energy, Biohazard, etc.
    self.arcDirection = ''    #Forward, Aft, Starboard, Port, Any
    self.arcRestriction = ''  #Arc or Fixed
    self.hardpoint = False    #set to True if weapon is part of a hardpoint option
    self.includeAsHardpoint = False #set to True if weapon is a hardpoint option AND was selected to ship
    self.rb1 = 0
    self.rb2 = 0
    self.rb3 = 0
    self.rb4 = 0
    self.rangeIncrement = 8  #range band distance
    return

########################################################################
class UpgradeRecord():
  """"""
  #----------------------------------------------------------------------
  def __init__(self):
    """Constructor"""
    self.index = 0
    self.cost = 0
    self.text = ''
    self.stringValue = ''
    self.intValue1 = 0
    self.intValue2 = 0
    self.selected = False  #used in the ship editor as a selection flag
    self.xor = []        #list of all other upgrades that are XOR, including this one.  used to determine which other upgrades are mutually exclusive
    self.color = None       #wxColor for display
    return

########################################################################
class squadronRecord():
  """"""
  #----------------------------------------------------------------------
  def __init__(self):
    """Constructor"""
    self.ship = None         #shipRecord of the main ship
    self.heavyCruiser = None  #shipRecord if a heavy cruiser added
    self.tier = None
    self.name = ''
    self.size = 1            # total size of the squadron without heavy or accompaniments
    self.cost = 0            # total point cost of the squadron
    self.treeItemSquadron = None
    self.treeItemShip = None
    self.treeItemShipHeavyCruiser = None
    self.treeItemShipAccomp = None
    self.notes = ""     #user defined notes
    self.printY = 0         #used when printing; gives the size in pixels of the squadron print
    return
  
  def __deepcpy__(self, source):
    item = squadronRecord()
    item.ship = source.ship
    item.heavyCruiser = source.heavyCruiser
    item.tier = source.tier
    item.name = source.name
    item.size = source.size
    return item

########################################################################
class HardpointRecord():
  """"""
  #----------------------------------------------------------------------
  def __init__(self):
    """Constructor"""
    self.index = 0        #unique to the kind of hardpoint
    self.numAvailable = 1   #if multiple selections are allowed, how many?
    self.numSelected = 1   # if multiple allowed, how many are installed?
    self.description = ''
    self.cost = 0
    self.intValue1 = 0  #usage of the value depends on the hardpoint
    self.intValue2 = 0
    self.intValue3 = 0
    self.strValue1 = ''
    self.strValue2 = ''
    self.marValue = None  #some hardpoints include a mar with other stats (ie, +2AP, Second Assault MAR)
    return

#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-

class PageRecord():
  def __init__(self,width=0, height=0, bitmap=None, resolution=0, dc=None):
    self.pageWidth = width            # size in pixels
    self.pageHeight = height          # size in pixels
    self.pageBitmap = bitmap          # wxBitmap for printing
    self.pageResolution = resolution  # dpi resolution to print at
    self.pageDC = dc                  # wxMemoryDC of the page
    return